Index: org/postgresql/jdbc2/AbstractJdbc2DatabaseMetaData.java
===================================================================
RCS file: /projects/cvsroot/pgsql-server/src/interfaces/jdbc/org/postgresql/jdbc2/AbstractJdbc2DatabaseMetaData.java,v
retrieving revision 1.6
diff -c -p -r1.6 AbstractJdbc2DatabaseMetaData.java
*** org/postgresql/jdbc2/AbstractJdbc2DatabaseMetaData.java	29 May 2003 04:39:48 -0000	1.6
--- org/postgresql/jdbc2/AbstractJdbc2DatabaseMetaData.java	7 Jul 2003 16:13:27 -0000
*************** public abstract class AbstractJdbc2Datab
*** 109,114 ****
--- 109,120 ----
  
  	/*
  	 * Return user defined types in a schema
+ 	 
+ 	 * select * from pg_catalog.pg_type t,pg_catalog.pg_namespace n where t.typnamespace <> n.oid and n.nspname = 'public' and typname not like 'pg_toast%';
+ 	 * int[] types is ignored as there is no distinction at this time ?
+ 	 * catalog is ignored 
+ 	 *
+ 	 * Issues: In PGSQL, are all types associated with a namespace?
  	 */
  	public java.sql.ResultSet getUDTs(String catalog,
  									  String schemaPattern,
*************** public abstract class AbstractJdbc2Datab
*** 116,122 ****
  									  int[] types
  									 ) throws SQLException
  	{
! 		throw org.postgresql.Driver.notImplemented();
  	}
  
  
--- 122,137 ----
  									  int[] types
  									 ) throws SQLException
  	{
! 		String sql = "select null as \"TYPE_CAT\", n.nspname as \"TYPE_SCHEM\", t.typname as \"TYPE_NAME\", null as \"CLASS_NAME\", null as \"DATA_TYPE\", null as \"REMARKS\" from pg_catalog.pg_type t, pg_catalog.pg_namespace n where t.typnamespace = n.oid and t.typname not like 'pg_toast%'";
! 		String toAdd = "";
! 		if (typeNamePattern != null || schemaPattern != null)
! 			{
! 			toAdd = " and n.nspname like ";
! 			toAdd += (typeNamePattern != null) ? "'"+typeNamePattern+"'" : "'"+schemaPattern+"'";
! 			}
! 		sql += toAdd;
! 		java.sql.ResultSet rs = connection.createStatement().executeQuery(sql);
! 		return rs;
  	}
  
  
